%global vertxhome %{_datadir}/vert.x
%global sysmodsdir %{vertxhome}/sys-mods

%global vertxversion 2.1
%global groupId io.vertx
%global languagename lang-js
%global modulename mod-lang-js

Name:        vertx-lang-js
Version:     1.1.0
Release:     1%{?dist}
Summary:     JavaScript language support for Vert.x platform

License:        ASL 2.0
URL:            https://github.com/vert-x/mod-lang-js

# Downloaded from https://github.com/vert-x/mod-lang-js/archive/lang-js-1.1.0.tar.gz
Source0:        https://github.com/vert-x/mod-lang-js/archive/lang-js-%{version}.tar.gz

BuildArch:        noarch

BuildRequires:    maven-local
BuildRequires:    maven-release-plugin
BuildRequires:    maven-resources-plugin
BuildRequires:    maven-source-plugin
BuildRequires:    maven-enforcer-plugin
BuildRequires:    maven-dependency-plugin
BuildRequires:    mvn(org.codehaus.mojo:exec-maven-plugin)

BuildRequires:    mvn(io.vertx:vertx-core)
BuildRequires:    mvn(io.vertx:vertx-platform)

BuildRequires:    java-devel >= 0:1.7.0

Requires:         vert.x >= 0:%{vertxversion}

%description
This is the Javascript language module used by mod-lang-dynjs and
mod-lang-rhino. This module is not typically used directly, but rather both 
mod-lang-rhino and mod-lang-dynjs have a dependency on this module which
provides the core Javascript API for Vert.x.

%prep
%setup -q -n %{modulename}-%{languagename}-%{version}

# Delte all binary .jar files
find .  -name "*.jar" -delete

## remove unused build extensions. Confirmed with developer that it is removable
sed -i "s/<extensions>/<!--extensions>/g" pom.xml
sed -i "s/<\/extensions>/<\/extensions-->/g" pom.xml

## Remove unused dependencies
# No io.vertx:testtools available
%pom_remove_dep io.vertx:testtools pom.xml

# Currently don't generate JSDoc, because it needs an customized Mozilla Rhino
%pom_remove_plugin org.codehaus.mojo:exec-maven-plugin pom.xml

# Remove unused plugin
%pom_remove_plugin com.googlecode.maven-java-formatter-plugin:maven-java-formatter-plugin pom.xml
%pom_remove_plugin org.apache.maven.plugins:maven-failsafe-plugin pom.xml

%build
export MAVEN_OPTS="-Xms256m -Xmx768m -XX:PermSize=128m -XX:MaxPermSize=256m"

# JUnit test failures
# only version 2.8 of maven-dependency-plugin in f21
%mvn_build -f -- -Dmaven.dependency.plugin.version=2.8

%install
%mvn_install

install -d -m 755 $RPM_BUILD_ROOT%{sysmodsdir}

# Install system module directory: io.vertx~lang-js~1.1.0
install -d -m 755 $RPM_BUILD_ROOT%{sysmodsdir}/%{groupId}~%{languagename}~%{version}
unzip -d $RPM_BUILD_ROOT%{sysmodsdir}/%{groupId}~%{languagename}~%{version} target/%{languagename}-%{version}-mod.zip

%files -f .mfiles
%doc LICENSE.txt README.md
%{_javadir}/*
%dir %{sysmodsdir}
%{sysmodsdir}/%{groupId}~%{languagename}~%{version}/*

%changelog
* Thu Jun 26 2014 Lin Gao <lgao@redhat.com> 1.1.0-1
- Initial packaging
